{$APPTYPE GUI}
{$IFDEF FPC}
// Added by bero
{$MODE Delphi}
{$IFDEF CPUI386}
{$DEFINE CPU386}
{$ASMMODE INTEL}
{$ENDIF}
{$IFNDEF WIN32}
{$LINKLIB c}
{$ENDIF}
{$ENDIF}
//********************************************************************
PROGRAM Main;
//********************************************************************
// TODO:
//
// Fehlt noch im GraphicSupport:
//   - TShape.Triangulate
//   - TShape.Load
//   - TShape.Hit
//   - JPG-Loader
//
// Fehlt noch in der GUI:
//   - Darstellung inaktiver Widgets?
//   - Systemmenu: Maximieren/Minimieren/Normalisieren/Beenden
//   - DataProvider XML/Binary 
//   - Exceptions anbringen
//   - Scriptanbindung??
//   - Descendants bisher:
//     Button,CheckBox,Image,Label,Panel,ProgressBar,ScrollBar,
//     SymbolBtn
//   - Sprachen? - Hints! "Internationalisierung von Anwendungen"
//
// Probleme:
//   - Doppelte Zeichenmittel werden vom GraphManager nicht angenommen
//********************************************************************
Uses

   SysUtils,
   OSSupport,
   GraphicSupport,
   GUI,
   GUIDescendanTS,
   Administrator,
   Render3D;

Var
   WindowClassName: String;
   MyValue: Single;
   I: Integer;

   Admin: TAdministrator;
   MainWindow,OnIdleWindow: TGUIWindow;
   Panel1,Panel2: TGUIPanel;
   MinBtn,MaxBtn,NormBtn,CloseBtn,Button2: TGUIButton;
   CheckBox1: TGUICheckBox;
   Label1: TGUILabel;
   Image1: TGUIImage;
   ScrollBar1: TGUIScrollHorizBar;
   ScrollBar2: TGUIScrollVertBar;
   ProgressBar1: TGUIProgressBar;
   ListBox1: TGUIListBox;

//********************************************************************
Procedure RenderMainWindow(APointer: Pointer);
Begin
   RenderQuadOnPaint(MainWindow);
End;
//********************************************************************
Procedure OnClickDestroyBtn(APointer: Pointer; X,Y,AddKeys: Integer);
Begin
   Admin.DestroyWindow(MainWindow);
End;
//********************************************************************
Procedure OnClickNormBtn(APointer: Pointer; X,Y,AddKeys: Integer);
Begin
   MainWindow.Normalize;
End;
//********************************************************************
Procedure OnClickMaxBtn(APointer: Pointer; X,Y,AddKeys: Integer);
Begin
   MainWindow.Maximize;
End;
//********************************************************************
Procedure OnClickMinBtn(APointer: Pointer; X,Y,AddKeys: Integer);
Begin
   MainWindow.Minimize;
End;
//********************************************************************
Procedure GetIdleKey(APointer: Pointer; AKey,PreviousKey: LongWord);
Begin
   If AKey = KEY_INSERT Then OnIdleWindow.Visible:= True;
   If AKey = KEY_DELETE Then OnIdleWindow.Visible:= False;
End;
//********************************************************************
Procedure RenderOnIdleWindow(APointer: Pointer);
Begin
   RenderQuadOnIdle(OnIdleWindow);
End;
//********************************************************************
// MAINPROGRAM
Begin
   WindowClassName:= 'GUIWindow';

   Admin:= TAdministrator.Create(WindowClassName);

   // Create GUI for MainWindow --------------------------------------
   MainWindow:= TGUIWindow.Create('MainWindow',Admin,TRUE,
      WindowClassName,'MainWindow',TRUE,100,100,500,500);
   // Button fr Schriftkontrolle
   {CloseBtn:= TButton.Create('CloseBtn',MainWindow,
      MainWindow.Left+200, MainWindow.Top+4, 300,30,
                   'abcdefghijklmnopqrstuvwxyz');
                   //'ABCDEFGHIJKLMNOPQRSTUVWXYZ'); }

   Panel1:= TGUIPanel.Create('Panel1',MainWindow,8,8,160,220);

   MinBtn:= TGUIButton.Create('Button1A',Panel1,
               Panel1.Left+30, Panel1.Top+30, 100,30,'Min');
   MaxBtn:= TGUIButton.Create('Button1B',Panel1,
               Panel1.Left+30, Panel1.Top+70, 100,30,'Max');
   NormBtn:= TGUIButton.Create('Button1B',Panel1,
               Panel1.Left+30, Panel1.Top+110, 100,30,'Norm');
   CloseBtn:= TGUIButton.Create('Button1B',Panel1,
               Panel1.Left+30, Panel1.Top+150, 100,30,'Close');

   // Greate GUI for IdleWindow --------------------------------------
   OnIdleWindow:= TGUIWindow.Create('OnIdleWindow',Admin,FALSE,
      WindowClassName,'Demo: RenderOnIdle',FALSE,250,250,400,400);

   LocalRenderContext:= RenderContextCreate(OnIdleWindow.Handle);
   OnIdleWindow.RenderContext:= LocalRenderContext;

   Panel2:= TGUIPanel.Create('Panel2',OnIdleWindow,8,8,340,340);
   //Panel2.FadeIn:= True;

   {Button2:= TGUIButton.Create('Button2',Panel2,
               Panel2.Left+100, Panel2.Top+100, 50,50,'ABC');

   ScrollBar1:= TGUIScrollHorizBar.Create('Label1',Panel2,
         Panel2.Left+20, Panel2.Top+20, 300,25);
   ScrollBar1.Align:= alTop; }

   {ScrollBar2:= TGUIScrollVertBar.Create('Label1',Panel2,
         Panel2.Left+300, Panel2.Top+20, 25,300);
   ScrollBar2.Align:= alRight; }

   ListBox1:= TGUIListBox.Create('ListBox1',Panel2,
               Panel2.Left+20, Panel2.Top+20, 300,300);
   With ListBox1 Do For I:= 0 To 39 Do Begin
      Items[I]:= 'Listboxeintrag '+IntToStr(I);
   End;
   ListBox1.ItemIndex:= 5; 
   //-----------------------------------------------------------------

   With Admin Do Begin
      // Initialize GraphicTools of Render3D
      With MainWindow.GraphTool Do Begin
         MyColor:= ColorByName['SOLIDWHITE'];
         MyImage:= ImageByName['FIGURES64X64'];
         MyFont:= FontByIndex[0];
      End;

      // Initialize eventhandling ------------------------------------
      // 1) MAINWINDOW
      MainWindow.OnPaint:= GetNotifyEvent(@RenderMainWindow);
      MinBtn.OnMouseBtnLUp:= GetMouseBtnEvent(@OnClickMinBtn);
      MaxBtn.OnMouseBtnLUp:= GetMouseBtnEvent(@OnClickMaxBtn);
      NormBtn.OnMouseBtnLUp:= GetMouseBtnEvent(@OnClickNormBtn);
      CloseBtn.OnMouseBtnLUp:= GetMouseBtnEvent(@OnClickDestroyBtn);
      MainWindow.TREEPaint;

      // 2) IDLEWINDOW
      IdleWindow:= OnIdleWindow;
      OnIdleWindow.OnIdle:= GetNotifyEvent(@RenderOnIdleWindow);
      OnIdleWindow.OnKeyDown:= GetKeyEvent(@GetIdleKey);
      OnIdleWindow.TREEPaint;

      // Initialize eventpipeline from operating system --------------
      InitEventPipeline;

      // MAINLOOP
      While Not Done Do Begin
         ProcessEvent;
         Sleep(40);
      End;
   End;
   If LocalRenderContext <> 0
      Then RenderContextFree(OnIdleWindow.Handle,LocalRenderContext);
   Admin.Free;
End.


